program inversion_de_matrice
  implicit none


  interface

     subroutine menu_programme(nbrlignecollone)
       integer, intent(in) :: nbrlignecollone
     end subroutine menu_programme

     subroutine choix_utilisateur(choix)
       integer, intent(in) :: choix
     end subroutine choix_utilisateur

     subroutine permutation_ligne(A, nbrlignecollone, ind_ligne1, ind_ligne2, B)
       integer, intent(in) :: nbrlignecollone, ind_ligne1, ind_ligne2
       real,dimension(nbrlignecollone,nbrlignecollone) :: A, B
     end subroutine permutation_ligne

     subroutine pivot(etape_pivot, A, nbrlignecollone, B, nbrcolloneB) 
       integer, intent(in) :: nbrlignecollone, nbrcolloneB, etape_pivot
       real,dimension(nbrlignecollone,nbrlignecollone) :: A, B
     end subroutine pivot

     subroutine sys_triang(A, nbrlignecollone, B, C)
       integer, intent(in) :: nbrlignecollone
       real,dimension(nbrlignecollone,nbrlignecollone) :: A, B, C
     end subroutine sys_triang

     subroutine saisir(A, nbrlignecollone)
       integer, intent(in) :: nbrlignecollone
       real,dimension(nbrlignecollone,nbrlignecollone) :: A
     end subroutine saisir

     subroutine affiche(A,nbrlignecollone)
       integer, intent(in) :: nbrlignecollone
       real,dimension(nbrlignecollone,nbrlignecollone) :: A
     end subroutine affiche

     function rech_ligne_pivot(A, nbrlignecollone, num_collone_rech)
       integer :: nbrlignecollone, num_collone_rech
       real,dimension(nbrlignecollone,nbrlignecollone) :: A
     end function rech_ligne_pivot

  end interface

  integer :: choix, nbrlignecollone

  call system("clear")

  call menu_programme(nbrlignecollone)

  call choix_utilisateur(choix)

  do while((choix.LT.0).AND.(choix.GT.3))
     write(*,*)
     write(*,"('Choix indisponible Veuillez ressaisir votre choix')" , advance='no')
     write(*,*)

  end do

  do while(choix.NE.3)
     call saisir(A, nbrlignecollone)
     select case(choix)

     case(1)

        real :: det = determinant(A,nbrlignecollone)
        write(*,*)
        write(*,"('Le determinant de la matrice A est : ')" , advance='no')
	write(*,*) det
        call system("clear")
	call menu_programme(nbrlignecollone)

     case(2)

	det = determinant(A,nbrlignecollone)
	if(det.NE.0) then
           inv = inverse(A,nbrlignecollone)
	else
	   write(*,*)
           write(*,"('Cette matrice n est pas inversible! ')" , advance='no')
	   write(*,*) det
           write(*,"('Veuillez recommencer')" , advance='no') det
	   write(*,*)
	   call system("clear")
	   call menu_programme(nbrlignecollone)
	end if

     end select
  end do

  stop "Fin du programme"

contains

  function determinant(A, nbrlignecollone)

    integer :: nbrlignecollone, i, etape_pivot, pballocation
    real :: det, determinant
    real,dimension(:,:), allocatable :: A, B

    allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
    allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )

    if(pballocation >0) then
       stop "Erreur : Probleme de mémoire"
    end if

    i=1
    do while (i.LE.nbrlignecollone)
       etape_pivot= rech_ligne_pivot(A, nbrlignecollone,i)
       if (etape_pivot.EQ.0) then
          det = 0
          return
       endif
       if (i.NE.etape_pivot) then
          call permutation_ligne(A, nbrlignecollone, i, etape_pivot, A)
       endif
       call pivot(etape_pivot, A, nbrlignecollone, B, 1)
       i=i+1
    end do
    det = A(1,1)
    do i=2, nbrlignecollone
       det = det*A(i,i)
    end do
    determinant = det
    return 
  end function determinant

  function inverse(A, nbrlignecollone)

    integer :: nbrlignecollone, i, j, k, l, etape_pivot, pballocation
    real,dimension(:,:), allocatable :: A, B, C, inverse

    allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
    allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )
    allocate( C(nbrlignecollone,nbrlignecollone), stat=pballocation )
    allocate( inverse(nbrlignecollone,nbrlignecollone), stat=pballocation )

    if(pballocation >0) then
       stop "Erreur : Probleme de mémoire"
    end if

!!! Création matrice identité : 

    do i=1, nbrlignecollone
       do j=1, nbrlignecollone
          B(i,j) = 0
       end do
       B(i,i) = 1
    end do

    k=1

    do while (k.LE.nbrlignecollone)
       etape_pivot = rech_ligne_pivot(A, nbrlignecollone,k)
       if(k.NE.etape_pivot) then
          call permutation_ligne(A, nbrlignecollone, k, etape_pivot, A)
          call permutation_ligne(B, nbrlignecollone, k, etape_pivot, B)
       endif
       call pivot(etape_pivot, A, nbrlignecollone, B, nbrlignecollone)
       i=i+1
    end do
    call sys_triang(A, nbrlignecollone, B, C)
    inverse = C
    return
  end function inverse

end program inversion_de_matrice

