subroutine saisir(A, nbrlignecollone)

  integer :: nbrlignecollone, i, j, pballocation
  real,dimension(:,:), allocatable :: A

  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if

  do i=1,nbrlignecollone	
     do j=1,nbrlignecollone
        write(*,*)
        write(*,"('Entrez les valeurs de la matrice ligne par ligne : ')", advance ='no')
        read *, A(i,j)
        write(*,*)
     end do
  end do

end subroutine saisir

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


subroutine menu_programme(nbrlignecollone)

  integer :: nbrlignecollone

  write(*,*)
  write(*,"('Bonjour,')")
  write(*,*)
  write(*,"('Ce programme vous permet de Calculer l inverse d une matrice caree si elle est inversible et son determinant')")
  write(*,*)
  write(*,"('Veuillez entrer la dimension de la matrice caree :')")
  read *, nbrlignecollone
  write(*,*)
  write(*,"('Vous avez le choix entre :')")
  write(*,*)
  write(*,"('[1] - Calculer le determinant d une matrice caree')")
  write(*,*)
  write(*,"('[2] - Calculer l inverse d une matrice caree')")
  write(*,*)
  write(*,"('[3] - Sortir')")
  write(*,*)

end subroutine menu_programme

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine choix_utilisateur(choix)

  integer :: choix

  write(*,*) 
  write(*,"('Saisissez votre choix :')",advance='no')
  write(*,*)	
  read*,choix 

end subroutine choix_utilisateur

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine affiche(A,nbrlignecollone)

  integer :: nbrlignecollone, pballocation
  real,dimension(:,:), allocatable :: A

  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if

  write(*,"('voici la valeur de la matrice:')",advance='no')
  write(*,*)
  do i=1,nbrelignecollone
     write(*,*) A(i,:)
  end do

end subroutine affiche


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function rech_ligne_pivot(A, nbrlignecollone, num_collone_rech)

  integer :: nbrlignecollone, num_collone_rech, num_pivot, pballocation, rech_ligne_pivot
  real,dimension(:,:), allocatable :: A

  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if

  num_pivot = num_collone_rech

  do while ((num_pivot.LE.nbrlignecollone).AND.(A(num_pivot,num_collone_rech).EQ.0))
     num_pivot=num_pivot+1
  end do

  if(num_piv.GT.nbrlignecollone) then
     num_pivot = 0
  end if
  rech_ligne_pivot = num_pivot
  return

end function rech_ligne_pivot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine permutation_ligne(A, nbrlignecollone, ind_ligne1, ind_ligne2, B)

  integer :: i, nbrlignecollone, ind_ligne1, ind_ligne2, pballocation
  real :: k
  real,dimension(:,:), allocatable :: A, B

  allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )
  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )

  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if


  call duplication_mat(A, nbrlignecollone, B)
  do i=1, nbrelignecollone
     k=A(ind_ligne1, j)
     B(ind_ligne1, i) = A(ind_ligne2, i)
     B(ind_ligne2, i) = k
  end do

  stop "Fin Subroutine"

contains

  subroutine duplication_mat(A, nbrlignecollone, B)

    integer :: nbrlignecollone, i,j, pballocation
    real,dimension(:,:), allocatable :: A, B

    allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
    allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )
    if(pballocation >0) then
       stop "Erreur : Probleme de mémoire"
    end if

    do i=1,nbrlignecollone	
       do j=1,nbrlignecollone
          B(i,j)=A(i,j)
       end do
    end do

  end subroutine duplication_mat

end subroutine permutation_ligne


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine pivot(etape_pivot, A, nbrlignecollone, B, nbrcolloneB)    !!! si pbl nbr_collone_B

  integer :: i, j,  nbrlignecollone, nbrcolloneB, etape_pivot, pballocation
  real :: piv, k
  real,dimension(:,:), allocatable :: A, B
  allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )
  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if



  piv = A(etape_pivot,etape_pivot)
  do i=etape_pivot+1, nbrlignecollone
     k=A(i, etape_pivot)
     A(i, etape_pivot) = 0
     do j=etape_pivot+1, nbrlignecollone
        A(i,j) = A(i,j) - ((A(etape_pivot, j)*k)/etape_piv)
     end do
     do j=1, nbrcolloneB
        B(i,j) = B(i,j) - ((B(etape_pivot, j)*k)/piv)
     end do
  end do

end subroutine pivot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sys_triang(A, nbrlignecollone, B, C)

  integer :: nbrlignecollone, i, j, l, pballocation
  real :: k
  real,dimension(:,:), allocatable :: A, B, C

  allocate( A(nbrlignecollone,nbrlignecollone), stat=pballocation )
  allocate( B(nbrlignecollone,nbrlignecollone), stat=pballocation )
  allocate( C(nbrlignecollone,nbrlignecollone), stat=pballocation )

  if(pballocation >0) then
     stop "Erreur : Probleme de mémoire"
  end if

  do l=1, nbrlignecollone
     C(nbrlignecollone, l) = (B(nbrlignecollone, l)/A(nbrlignecollone, nbrlignecollone))
     do i=nbrligncollone-1, 1, -1
        k=0
        do j=i+1, m
           k = k+C(j,l)*A(i,j)
        end do
        C(i, l) = ((B(i,l) - k))/A(i,i) 
     end do
  end do

end subroutine sys_triang

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

